Panda3D

Public Member Functions | Static Public Member Functions | Friends | List of all members
CollisionHandler Class Reference

The abstract interface to a number of classes that decide what to do when a collision is detected. More...

`#include "collisionHandler.h"`

Inheritance diagram for CollisionHandler:

## Public Member Functions
virtual void | add_entry (CollisionEntry *entry)
| Called between a begin_group() . More...
virtual void | begin_group ()
| Will be called by the CollisionTraverser before a new traversal is begun. More...
virtual bool | end_group ()
| Called by the CollisionTraverser at the completion of all collision detections for this traversal. More...
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
void | set_root (const NodePath &root)
| Sets the root of the collision traversal. More...
bool | wants_all_potential_collidees () const
| Returns true if handler wants to know about all solids that are within the collider's bounding volume. More...
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Friends
class | CollisionTraverser

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Detailed Description

The abstract interface to a number of classes that decide what to do when a collision is detected.

One of these must be assigned to the CollisionTraverser that is processing collisions in order to specify how to dispatch detected collisions.

Definition at line 30 of file collisionHandler.h.

## Member Function Documentation

## ◆ add_entry()

void CollisionHandler::add_entry | ( | CollisionEntry * | entry | ) |
| virtual

Called between a begin_group() .

. end_group() sequence for each collision that is detected.

Reimplemented in CollisionHandlerQueue, CollisionHandlerPhysical, CollisionHandlerHighestEvent, CollisionHandlerFluidPusher, and CollisionHandlerEvent.

Definition at line 39 of file collisionHandler.cxx.

## ◆ begin_group()

void CollisionHandler::begin_group | ( |  | ) |
| virtual

Will be called by the CollisionTraverser before a new traversal is begun.

It instructs the handler to reset itself in preparation for a number of CollisionEntries to be sent.

Reimplemented in CollisionHandlerQueue, CollisionHandlerPhysical, CollisionHandlerHighestEvent, and CollisionHandlerEvent.

Definition at line 31 of file collisionHandler.cxx.

## ◆ end_group()

bool CollisionHandler::end_group | ( |  | ) |
| virtual

Called by the CollisionTraverser at the completion of all collision detections for this traversal.

It should do whatever finalization is required for the handler.

The return value is normally true, but if this returns value, the CollisionTraverser will remove the handler from its list, allowing the CollisionHandler itself to determine when it is no longer needed.

Reimplemented in CollisionHandlerPhysical, CollisionHandlerHighestEvent, and CollisionHandlerEvent.

Definition at line 52 of file collisionHandler.cxx.

## ◆ set_root()

void CollisionHandler::set_root | ( | const NodePath & | root | ) |
| inline

Sets the root of the collision traversal.

Only set if wants_all_potential_collidees is true

Definition at line 27 of file collisionHandler.I.

## ◆ wants_all_potential_collidees()

bool CollisionHandler::wants_all_potential_collidees | ( |  | ) | const
| inline

Returns true if handler wants to know about all solids that are within the collider's bounding volume.

Definition at line 18 of file collisionHandler.I.

The documentation for this class was generated from the following files:

- panda/src/collide/collisionHandler.h
- panda/src/collide/collisionHandler.cxx
- panda/src/collide/collisionHandler.I